# std::is_abstract

From cppreference.com
< cpp‎ | types

Defined in header `<type_traits>` |  |
template< class T > struct is_abstract; |  | (since C++11)

If `T` is an abstract class (that is, a non-union class that declares or inherits at least one pure virtual function), provides the member constant `value` equal true. For any other type, `value` is false.

If `T` is a non-union class type, `T` shall be a complete type; otherwise, the behavior is undefined.

### Template parameters

T | - | a type to check

### Helper variable template

template< class T > inline constexpr bool is_abstract_v = is_abstract<T>::value; |  | (since C++17)

## Inherited from std::integral_constant

### Member constants

value [static] | true if `T` is an abstract class type , false otherwise (public static member constant)

### Member functions

operator bool | converts the object to bool, returns `value` (public member function)
operator() (C++14) | returns `value` (public member function)

### Member types

Type | Definition
`value_type` | `bool`
`type` | std::integral_constant<bool, value>

### Example

Run this code

    #include <iostream>
    #include <type_traits>

    struct A {
        int m;
    };

    struct B {
        virtual void foo();
    };

    struct C {
        virtual void foo() = 0;
    };

    struct D : C {};

    int main()
    {
        std::cout << std::boolalpha;
        std::cout << std::is_abstract<A>::value << '\n';
        std::cout << std::is_abstract<B>::value << '\n';
        std::cout << std::is_abstract<C>::value << '\n';
        std::cout << std::is_abstract<D>::value << '\n';
    }

Output:

    false
    false
    true
    true

### See also

is_class (C++11) | checks if a type is a non-union class type (class template)
is_polymorphic (C++11) | checks if a type is a polymorphic class type (class template)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/types/is_abstract&oldid=91005"